/*
 * The following defines are for compatibility with 2.6
 */
/*
 * container_of - cast a member of a structure out to the containing structure
 * @ptr: the pointer to the member.
 * @type:   the type of the container struct this is embedded in.
 * @member: the name of the member within the struct.
 */
#define container_of(ptr, type, member) ({         \
   const typeof( ((type *)0)->member ) *__mptr = (ptr);  \
   (type *)( (char *)__mptr - offsetof(type,member) );})


static inline unsigned iminor(struct inode *inode)
{
   return MINOR(inode->i_rdev);
}

static inline unsigned imajor(struct inode *inode)
{
   return MAJOR(inode->i_rdev);
}
